<template>
  <q-dialog
    v-model="popupFullSize"
    persistent
    :maximized="maximizedToggle"
    transition-show="slide-up"
    transition-hide="slide-down"
    ref="dialogRef"
  >
    <q-card class="">
      <q-bar>
        <q-space />
        <q-btn
          dense
          flat
          icon="minimize"
          @click="maximizedToggle = false"
          :disable="!maximizedToggle"
        >
          <q-tooltip v-if="maximizedToggle" class="bg-white text-primary"
            >Minimize</q-tooltip
          >
        </q-btn>
        <q-btn
          dense
          flat
          icon="crop_square"
          @click="maximizedToggle = true"
          :disable="maximizedToggle"
        >
          <q-tooltip v-if="!maximizedToggle" class="bg-white text-primary"
            >Maximize</q-tooltip
          >
        </q-btn>
        <q-btn dense flat icon="close" v-close-popup>
          <q-tooltip class="bg-white text-primary">Close</q-tooltip>
        </q-btn>
      </q-bar>
      <q-card-section>
        <div class="text-h6">{{ windowObj.title }}</div>
      </q-card-section>
      <q-card-section class="q-pt-none">
        <form action="">
          actuel: {{ windowObj.name }}
          <q-input filled v-model="updateFieldName" label="nom" type="text" />
          <br />actuel: {{ windowObj.color }}
          <q-color
            v-model="updateFieldColor"
            no-header-tabs
            class="my-picker"
            default-view="palette"
          />
          <br />actuel: {{ windowObj.comment }}
          <q-input
            filled
            v-model="updateFieldComment"
            label="commentaire"
            type="text"
          />
          <q-btn
            @click.prevent="updateField(windowObj)"
            label="enregistrer les modifications"
            type="submit"
            color="primary"
            icon="save_as"
          />
        </form>
        <h6>supprimer le champ</h6>
        <form action="">
          <q-btn
            @click.prevent="deleteField(windowObj.id)"
            label="supprimer le champ"
            type="submit"
            color="negative"
            icon="delete"
          />
        </form>
        <div class="dev">
          <p>windowObj.id: {{ windowObj.id }}</p>
          <p>windowObj.type: {{ windowObj.type }}</p>
          <p>windowObj.title: {{ windowObj.title }}</p>
          <p>windowObj.name: {{ windowObj.name }}</p>
          <p>windowObj.color: {{ windowObj.color }}</p>
          <p>windowObj.comment: {{ windowObj.comment }}</p>
        </div>
      </q-card-section>
    </q-card>
  </q-dialog>
</template>
<script>
import { defineComponent, ref } from 'vue';
import { useQuasar, useDialogPluginComponent } from 'quasar';
import { useAuthStore } from 'src/stores/authStore.js';

export default defineComponent({

  props: {
    windowObj: {
      type: Object,
      required: true,
    },
  },

  emits: [
    ...useDialogPluginComponent.emits,
  ],

  setup(props) {
    const quasar = useQuasar();
    const popupFullSize = ref('');
    const authStore = useAuthStore();
    const updateFieldName = ref('');
    const updateFieldColor = ref('');
    const updateFieldComment = ref('');
    const {
      dialogRef,
      onDialogHide,
      /* onDialogOK, *//* onDialogCancel, */
    } = useDialogPluginComponent();
    const maximizedToggle = ref(true);

    const updateField = (field) => {
      console.log(field);
      let updateFieldNameValue = '';
      let updateFieldColorValue = '';
      let updateFieldCommentValue = '';
      if (updateFieldName.value === '' || updateFieldName.value === null) {
        updateFieldNameValue = props.windowObj.name;
      } else {
        updateFieldNameValue = updateFieldName.value;
      }
      if (updateFieldColor.value === '' || updateFieldColor.value === null) {
        updateFieldColorValue = props.windowObj.color;
      } else {
        updateFieldColorValue = updateFieldColor.value;
      }
      if (updateFieldComment.value === '' || updateFieldComment.value === null) {
        updateFieldCommentValue = props.windowObj.comment;
      } else {
        updateFieldCommentValue = updateFieldComment.value;
      }
      popupFullSize.value = false;
      const requestOptionsConn = {
        method: 'PUT',
        headers: {
          'Content-Type': 'application/json',
          Authorization: `Bearer ${authStore.jwt}`,
        },
        body: JSON.stringify({
          content: {
            name: updateFieldNameValue,
            color: updateFieldColorValue,
            comment: updateFieldCommentValue,
          },
        }),
      };

      fetch(
        `${import.meta.env.VITE_FETCH_BACK}/users/${authStore.userId}/champs/${props.windowObj.id}`,
        requestOptionsConn,
      )
        .then((response) => {
          if (response.status !== 200) {
            quasar.dialog({
              title: 'Alert',
              message: 'un problème est survenu ...',
            });
            throw response.status;
          }
          return response.json();
        })
        .then((json) => {
          console.log(json);
          // push new info dans Pinia
          authStore.userObject.champs = json;
          // push new info dans LocalStorage
          // authStore.updateUserObject(authStore.userObject);
          popupFullSize.value = false; // close popup
          quasar.notify({
            message: 'le champ a été modifié',
            color: 'positive',
            badgeTextColor: 'white',
            progress: true,
          });
        });
    };
    const deleteField = (fieldId) => {
      const verifString = 'effacer ce champ';
      quasar.dialog({
        title: 'Confirmation',
        message: `Pour éviter toute mauvaise manipulation, écrivez "${verifString}"`,
        prompt: {
          model: '',
          type: 'text',
        },
        persistent: true,
        cancel: true,
      }).onOk((data) => {
        if (data !== verifString) {
          quasar.notify({
            message: 'mauvaise phrase de confirmation',
            color: 'negative',
            badgeTextColor: 'white',
            progress: true,
          });
          return false;
        }
        const requestOptionsConn = {
          method: 'DELETE',
          headers: {
            Authorization: `Bearer ${authStore.jwt}`,
          },
        };
        fetch(`${import.meta.env.VITE_FETCH_BACK}/users/${authStore.userId}/champs/${fieldId}`, requestOptionsConn)
          .then((response) => {
            if (response.status !== 200) {
              quasar.dialog({
                title: 'Alert',
                message: 'un problème est survenu ...',
              });
              throw response.status;
            }
            return response.json();
          })
          .then((json) => {
            console.log(json);
            // push new info dans Pinia
            authStore.userObject.champs = json;
            // push new info dans LocalStorage
            // authStore.updateUserObject(authStore.userObject);
            popupFullSize.value = false;
            quasar.notify({
              message: 'Le champ et ces données associé a été supprimer',
              color: 'positive',
              badgeTextColor: 'white',
              progress: true,
            });
          });
      });
    };
    return {
      dialogRef,
      onDialogHide,
      maximizedToggle,
      popupFullSize,
      updateFieldName,
      updateFieldColor,
      updateFieldComment,
      updateField,
      deleteField,
      ...props,
    };
  },
});
</script>
